#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ThirdPluginOnlyCFG.h"
std::auto_ptr<M_ThirdPluginOnlyCFG> M_ThirdPluginOnlyCFG::msSingleton(nullptr);

int M_ThirdPluginOnlyCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ThirdPluginOnlyCFGData* M_ThirdPluginOnlyCFG::GetData(std::string PackageName)
{
	auto it = mMapData.find(PackageName);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<std::string, M_ThirdPluginOnlyCFGData>& M_ThirdPluginOnlyCFG::GetMapData()
{
	return mMapData;
}

void M_ThirdPluginOnlyCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ThirdPluginOnlyCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ThirdPluginOnlyCFGData data;
		data.mPackageName = element->Attribute("PackageName");
		data.mChannelID = element->Attribute("ChannelID");
		data.mPlatform = element->Attribute("Platform");
		data.mRemark = element->Attribute("Remark");
		if (mMapData.find(data.mPackageName) != mMapData.end())std::cout <<"data refind:" << data.mPackageName << std::endl;
		CCASSERT(mMapData.find(data.mPackageName) == mMapData.end(), "data.mPackageName is exists");
		mMapData.insert(std::make_pair(data.mPackageName, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ThirdPluginOnlyCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ThirdPluginOnlyCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ThirdPluginOnlyCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ThirdPluginOnlyCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ThirdPluginOnlyCFGData data;
		LuaCfgHelper::readString(L, "PackageName", data.mPackageName);
		LuaCfgHelper::readString(L, "ChannelID", data.mChannelID);
		LuaCfgHelper::readString(L, "Platform", data.mPlatform);
		LuaCfgHelper::readString(L, "Remark", data.mRemark);
		if (mMapData.find(data.mPackageName) != mMapData.end())std::cout <<"data refind:" << data.mPackageName << std::endl;
		CCASSERT(mMapData.find(data.mPackageName) == mMapData.end(), "data.mPackageName is exists");
		mMapData.insert(std::make_pair(data.mPackageName, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ThirdPluginOnlyCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ThirdPluginOnlyCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ThirdPluginOnlyCFG* M_ThirdPluginOnlyCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ThirdPluginOnlyCFG());
	}
	return msSingleton.get();
}

void M_ThirdPluginOnlyCFG::Release()
{
	msSingleton.reset(nullptr);
}
